#!/system/bin/sh

# Replicant USB Networking
# ========================                             
# 
# Copyright (C) 2010 Paul Kocialkowski, GPLv3+
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# Enable USB Networking

USB_IFACE="usb0"

USB_IFACE_IP="192.168.4.202"
GATEWAY_IP="192.168.4.200"
DNS1_IP="8.8.8.8"

usb_networking_enable () {
	echo 1 > /sys/class/usb_composite/rndis/enable
	ifconfig usb0 up
}

usb_networking_configure () {
	ifconfig $USB_IFACE $USB_IFACE_IP
	route add default gw $GATEWAY_IP dev $USB_IFACE
	setprop net.dns1 $DNS1_IP

	# setprop net.dns1 $( cat /system/etc/resolv.conf | sed -e "s|.*#.*||" -e "s|^.*nameserver \(.*\)$|\1|g" | grep -v "^$" | head -n 1 )
}

usb_networking_disable () {
	echo 0 > /sys/class/usb_composite/rndis/enable
	ifconfig usb0 down
}

case $1 in
	"start")
		echo "Starting Replicant USB Networking"
		usb_networking_enable
		usb_networking_configure
	;;
	"stop")
		echo "Stopping Replicant USB Networking"
		usb_networking_disable
	;;
	*)
		echo "Usage: sh $0 {start|stop}"
	;;
esac
